#include "pch.hpp"
#include "Button.hpp"

void Button::Load(std::string filename, float2 const & position)
{
	bool result;
	result = image.loadFromFile(filename);
    assert(result);
    sprite.setTexture(image);
    sprite.setOrigin(image.getSize().x * 0.5f, image.getSize().y * 0.5f);
    sprite.setPosition(position);
    buttonPressed = false;
    wasMousePressed = false;
    clicked = false;
}

void Button::Update(void)
{
    if (!wasMousePressed)
    {
        clicked = false;
    }

    float2 mousePos = GetMousePos();

    if (!wasMousePressed && sf::Mouse::isButtonPressed(sf::Mouse::Left))
    {
        if (sprite.getGlobalBounds().contains(mousePos))
        {
            buttonPressed = true;
        }
    }
    else if (wasMousePressed && !sf::Mouse::isButtonPressed(sf::Mouse::Left))
    {
        if (sprite.getGlobalBounds().contains(mousePos) && buttonPressed)
        {
            clicked = true;
        }
    }
    wasMousePressed = sf::Mouse::isButtonPressed(sf::Mouse::Left);
    if (!wasMousePressed)
    {
        buttonPressed = false;
    }
}

bool Button::IsClicked(void)
{
    return clicked;
}

void Button::Render(void)
{
    window.draw(sprite);
}
