#include "pch.hpp"
#include "GameObject.hpp"

void GameObject::Load(sf::Texture & spriteSheet, uint frameCount, uint frameDuration, sf::FloatRect const & rect)
{
    InitCollider(rect);
    animation.Load(spriteSheet, frameCount, frameDuration);
    animation.SetPosition(position);
    animation.SetScale(float2(rect.width / animation.GetSize().x, rect.height / animation.GetSize().y));
}

Animation & GameObject::GetAnimation(void)
{
    return animation;
}

void GameObject::Update(void)
{
    animation.Update();
}

void GameObject::Render(void)
{
    animation.Render();
}
