#pragma once

#include "Screen.hpp"
#include <string>
#include "Monster.hpp"
#include "Player.hpp"
#include "Dot.hpp"
#include "PopupText.hpp"

class GameScreen : public Screen
{
    private:

	static const int maxColorVal = 255;
	static const int colorStep = 43;

	Sound whooshSound;
	Sound popSound;
	Sound lifeLostSound;
	sf::Music normalMusic;
	sf::Music comboMusic;
    sf::Text sampleText;
    sf::Font arialFont;
    sf::Font phreakFont;
    sf::Texture monsterImage;
    sf::RectangleShape background;
    sf::Texture playerImage;
    sf::Texture dotImage;
    sf::Texture glowImage;
	sf::Texture guiImage;
	Player player;
    std::vector<Dot *> dots;
    std::vector<Monster *> monsters;
    PopupText popupText;
    ObjectColor::Type lastColor;
    float colorAccum;
    sf::Texture life;
    sf::Sprite lives[3];
	sf::Sprite gui;
    uint playerLives;
    sf::RectangleShape stripes[4];
    float stripesTimer;
    float backgroundFlickerTimer;
    float flickeringTimer;
    bool stripesBonusAvailable;
    uint stripeDirection;
    float playerImmortalityTimer;
    uint score;
    uint comboCount;
    sf::Text scoreText;
    float lastPoints;

    void StartStripes(void);
    void SetScoreText(void);

    public:
    void Load(void);
    void Init(void);
    void HandleEvent(sf::Event const & event);
    void Update();
    void Render(void);
    void Unload(void);
};
