#include "pch.hpp"
#include "MenuScreen.hpp"

void MenuScreen::Load(void)
{
    buttonPlay.Load("data/button_play.png", float2(window.getSize().x * 0.5f, 400.0f));
    buttonTutorial.Load("data/button_tutorial.png", float2(window.getSize().x * 0.5f, 450.0f));
    buttonCredits.Load("data/button_credits.png", float2(window.getSize().x * 0.5f, 500.0f));
    buttonExit.Load("data/button_exit.png", float2(window.getSize().x * 0.5f, 550.0f));
	bool result;
	result = font.loadFromFile("data/VideoPhreak.ttf");
	assert(result);
	result = gameLogoImage.loadFromFile("data/game_logo.png");
    assert(result);
    gameLogoSprite.setTexture(gameLogoImage);
    gameLogoSprite.setOrigin(gameLogoImage.getSize().x * 0.5f, gameLogoImage.getSize().y * 0.5f);
    gameLogoSprite.setPosition(window.getSize().x * 0.5f, 145.0f);

	gameName.setFont(font);
	gameName.setCharacterSize(70);
	gameName.setPosition(100, 275);
	gameName.setString("The Conformist");
	gameName.setColor(sf::Color(255,255,255,255));
}

void MenuScreen::Init(void)
{
}

void MenuScreen::HandleEvent(sf::Event const & event)
{
}

void MenuScreen::Update()
{
    buttonPlay.Update();
    buttonTutorial.Update();
    buttonCredits.Update();
    buttonExit.Update();

    if (buttonPlay.IsClicked())
    {
        screenManager.SetCurrentScreen((Screen &)gameScreen);
        screenManager.Init();
    }
    else if (buttonTutorial.IsClicked())
    {
        screenManager.SetCurrentScreen((Screen &)tutorialScreen);
        screenManager.Init();
    }
    else if (buttonCredits.IsClicked())
    {
        screenManager.SetCurrentScreen((Screen &)creditsScreen);
        screenManager.Init();
    }
    else if (buttonExit.IsClicked())
    {
        window.close();
    }
}

void MenuScreen::Render(void)
{
    window.draw(gameLogoSprite);
    buttonPlay.Render();
    buttonTutorial.Render();
    buttonCredits.Render();
    buttonExit.Render();
	window.draw(gameName);
}

void MenuScreen::Unload(void)
{
}