#pragma once

#include "GameObject.hpp"
#include "Dot.hpp"
#include "Player.hpp"

class Monster : public GameObject
{
    private:
    ObjectColor::Type color;
	bool isVisible;
	bool isMoving;
	sf::Vector2f targetPos;

    public:
    void Load(sf::Texture & spriteSheet, sf::FloatRect const & rect, ObjectColor::Type _color);
    void Update(float2 playerPos);
    ObjectColor::Type GetColor(void);
    void SetColor(ObjectColor::Type _color);
	void SetVisible(bool isVisible);
	bool GetVisible(void);

    static Monster * SpawnRandomly(sf::Texture & monsterImage, std::vector<Dot *> const & dots,
        Player & player);
};
