#include "pch.hpp"
#include "ResultScreen.hpp"

void ResultScreen::Load(void)
{
	bool result = phreakFont.loadFromFile("data/VideoPhreak.ttf");
    assert(result);
    backButton.Load("data/button_back.png", float2(650.0f, 525.0f));
}

void ResultScreen::Init(void)
{
    sampleText.setFont(phreakFont);
    std::stringstream format;
    format << "Game over\n\nYou scored: " << gameScore;
    std::string line, whole;
    while (!format.eof())
    {
        std::getline(format, line);
        whole += line + '\n';
    }
    sampleText.setString(whole);
    sampleText.setCharacterSize(24);
    sampleText.setColor(sf::Color::White);
    sampleText.setOrigin(sampleText.getGlobalBounds().width * 0.5f, sampleText.getGlobalBounds().height * 0.5f);
    sampleText.setPosition(window.getSize().x * 0.5f, window.getSize().y * 0.5f);
}

void ResultScreen::HandleEvent(sf::Event const & event)
{
}

void ResultScreen::Update()
{
    backButton.Update();

    if (backButton.IsClicked())
    {
        screenManager.SetCurrentScreen((Screen &)menuScreen);
        screenManager.Init();
    }
}

void ResultScreen::Render(void)
{
    window.draw(sampleText);
    backButton.Render();
}

void ResultScreen::Unload(void)
{
}