#include "pch.hpp"
#include "TutorialScreen.hpp"

void TutorialScreen::Load(void)
{
	bool result = phreakFont.loadFromFile("data/VideoPhreak.ttf");
    assert(result);
    backButton.Load("data/button_back.png", float2(650.0f, 525.0f));
}

void TutorialScreen::Init(void)
{
    sampleText.setFont(phreakFont);
    sampleText.setString(
		"Controls:\n\n\
		Mouse L-Click and drag to move around\n\
		or use gamepad\n\n\
		Avoid creatures and collect shiny things\n (what are they anyway?)\n\
		The more you focus on one specific color\n the more you get points\n\
		When certain monster type disappears\n it starts to pursue you so watch out.");
    sampleText.setCharacterSize(24);
    sampleText.setColor(sf::Color::White);
    sampleText.setOrigin(sampleText.getGlobalBounds().width * 0.5f, sampleText.getGlobalBounds().height * 0.5f);
    sampleText.setPosition(window.getSize().x * 0.5f, window.getSize().y * 0.5f);
}

void TutorialScreen::HandleEvent(sf::Event const & event)
{
}

void TutorialScreen::Update()
{
    backButton.Update();

    if (backButton.IsClicked())
    {
        screenManager.SetCurrentScreen((Screen &)menuScreen);
        screenManager.Init();
    }
}

void TutorialScreen::Render(void)
{
    window.draw(sampleText);
    backButton.Render();
}

void TutorialScreen::Unload(void)
{
}