#pragma once

#include <cstdlib>
#include <vector>
#include <deque>
#include <string>
#include <algorithm>
#include <cassert>
#include <sstream>

#include <SFML/Audio.hpp>
#include <SFML/Graphics.hpp>
#include <SFML/Network.hpp>
#include <SFML/System.hpp>
#include <SFML/Window.hpp>
#include "RixMath.hpp"
#include "Miscellaneous.hpp"
#include "ScreenManager.hpp"
#include "Sound.hpp"
#include "Animation.hpp"
#include "PopupText.hpp"
#include "Parallax.hpp"

#pragma warning(disable : 4018)

namespace ObjectColor
{
    enum Type
    {
        Red,
        Green,
        Blue,
        Count
    };
}

class IntroScreen;
class MenuScreen;
class CreditsScreen;
class TutorialScreen;
class GameScreen;
class ResultScreen;

extern sf::RenderWindow window;
extern ScreenManager screenManager;
extern IntroScreen introScreen;
extern MenuScreen menuScreen;
extern CreditsScreen creditsScreen;
extern TutorialScreen tutorialScreen;
extern GameScreen gameScreen;
extern ResultScreen resultScreen;
extern const float ONE_SIXTIETH;
extern uint gameScore;
